"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dateRuleType = exports.ruleType = exports.phpType = void 0;
const typeMapper = {
    string: 'string',
    date: 'string|Carbon',
    int: 'int',
    float: 'float',
    bool: 'bool',
};
const ruleTypeMapper = {
    string: 'string',
    date: 'date',
    int: 'int',
    float: 'decimal',
    bool: 'boolean',
};
const dateSubTypeRuleMapper = {
    datetime: 'date_format:Y-m-d H:i:s',
    time: 'date_format:H:i:s',
    date: 'date',
};
function phpType(type) {
    return typeMapper[type];
}
exports.phpType = phpType;
function ruleType(column) {
    let rule = ruleTypeMapper[column.type];
    if (rule === 'decimal') {
        rule = `${rule}:0,${column.scale}`;
    }
    if (column.unsigned) {
        rule = `${rule}|min:0`;
    }
    return rule;
}
exports.ruleType = ruleType;
function dateRuleType(column) {
    return dateSubTypeRuleMapper[column.subType || 'date'];
}
exports.dateRuleType = dateRuleType;
