"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachRequest = void 0;
const base_1 = require("./base");
const th = __importStar(require("../../helpers/type"));
const naming_1 = __importDefault(require("../../helpers/naming"));
const ignoreCreateRulesFor = {
    created_at: true,
    updated_at: true,
};
class AttachRequest extends base_1.BaseTransformer {
    transform() {
        const result = [];
        for (const item of this.$items) {
            const model = naming_1.default.modelClass(item.table);
            const columnRules = this.columnRules(item);
            for (const relation of item.relations) {
                if (relation.type !== 'belongs-to') {
                    continue;
                }
                const relatedModel = naming_1.default.capitalizedRelationAttribute(relation, item.table);
                const rules = [];
                relation.columns.forEach((columnName) => {
                    rules.push({
                        attribute: columnName,
                        rules: columnRules[columnName],
                    });
                });
                result.push({
                    namespace: 'App\\Http\\Requests\\Generathor',
                    class: `Attach${relatedModel}To${model}Request`,
                    rules: rules,
                    errorBag: 'attach',
                });
            }
        }
        return result;
    }
    columnRules(item) {
        const columnRules = {};
        item.columns.forEach((column) => {
            const rules = ['required'];
            if (column.type === 'string' &&
                column.enum &&
                Array.isArray(column.enum)) {
                const rule = 'in:' + column.enum.join(',');
                rules.push(rule);
            }
            const ruleType = th.ruleType(column);
            if (column.type !== 'date') {
                rules.push(ruleType);
            }
            const dateRuleType = th.dateRuleType(column);
            if (column.type === 'date' && dateRuleType) {
                rules.push(dateRuleType);
            }
            if (!column.autoincrement) {
                if (!ignoreCreateRulesFor[column.name]) {
                    columnRules[column.name] = rules.join('|');
                }
            }
        });
        return columnRules;
    }
}
exports.AttachRequest = AttachRequest;
