import { Configuration } from '../../configuration';
import { Item, Relation } from 'generathor-db';
type FKDetails = {
    relationAttribute: string;
    table: string;
    context: string;
    routeRecordName: string;
};
export type TransformedItem = Record<string, any>;
export declare abstract class BaseTransformer {
    protected $items: Item[];
    protected $config: Configuration;
    constructor($items: Item[], $config: Configuration);
    abstract transform(): TransformedItem[];
    protected mapByTable(): Record<string, Item>;
    protected references(relation: Relation): Record<string, string>;
    protected fksByTable(): Record<string, Record<string, FKDetails>>;
    private fks;
}
export {};
