"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseTransformer = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
class BaseTransformer {
    constructor($items, $config) {
        this.$items = $items;
        this.$config = $config;
    }
    mapByTable() {
        const map = {};
        for (const item of this.$items) {
            map[item.table] = item;
        }
        return map;
    }
    references(relation) {
        const references = {};
        for (const index in relation.references) {
            references[relation.references[index]] = relation.columns[index];
        }
        return references;
    }
    fksByTable() {
        const map = {};
        for (const item of this.$items) {
            map[item.table] = this.fks(item);
        }
        return map;
    }
    fks(item) {
        const fks = {};
        item.relations.forEach((relation) => {
            if (relation.type !== 'belongs-to') {
                return;
            }
            const relationColumnKeys = Object.keys(relation.columns);
            const relationAttribute = naming_1.default.relationAttribute(relation, item.table);
            if (relationColumnKeys.length === 1) {
                fks[relation.columns[0]] = {
                    relationAttribute,
                    table: relation.on.table,
                    context: naming_1.default.context(relation.on.table),
                    routeRecordName: naming_1.default.recordName(relation.on.table),
                };
            }
        });
        return fks;
    }
}
exports.BaseTransformer = BaseTransformer;
