"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseTransformer = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
class BaseTransformer {
    constructor($item, $config) {
        this.$item = $item;
        this.$config = $config;
    }
    fks() {
        const fks = {};
        this.$item.relations.forEach((relation) => {
            if (relation.type !== 'belongs-to') {
                return;
            }
            const relationColumnKeys = Object.keys(relation.columns);
            const relationAttribute = naming_1.default.relationAttribute(relation, this.$item.table);
            if (relationColumnKeys.length === 1) {
                fks[relation.columns[0]] = {
                    relationAttribute,
                    table: relation.on.table,
                    context: naming_1.default.context(relation.on.table),
                    routeRecordName: naming_1.default.recordName(relation.on.table),
                };
            }
        });
        return fks;
    }
}
exports.BaseTransformer = BaseTransformer;
