"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Filter = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
const base_1 = require("./base");
class Filter extends base_1.BaseTransformer {
    transform() {
        const fks = this.fks();
        const pkMap = this.pkMap();
        this.$item.laravel.filter = {
            class: naming_1.default.modelClass(this.$item.table) + 'Filter',
            namespace: 'App\\ModelFilters',
            columns: this.$item.columns.map((column) => {
                let type = column.type;
                if (pkMap[column.name]) {
                    type = 'key';
                }
                else if (fks[column.name]) {
                    type = 'record';
                }
                return {
                    type,
                    name: column.name,
                    attribute: naming_1.default.columnAttribute(column),
                };
            }),
        };
    }
    pkMap() {
        const pkMap = {};
        const columns = this.$item.primaryKey ? this.$item.primaryKey.columns : [];
        for (const column of columns) {
            pkMap[column] = true;
        }
        return pkMap;
    }
}
exports.Filter = Filter;
