"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Laravel = void 0;
const eloquent_1 = require("./eloquent");
const forms_1 = require("./forms");
const filter_1 = require("./filter");
const requests_1 = require("./requests");
const base_1 = require("./base");
const list_1 = require("./list");
const edit_1 = require("./edit");
const show_1 = require("./show");
class Laravel extends base_1.BaseTransformer {
    constructor($item, $config) {
        super($item, $config);
        this.$item = $item;
        this.$config = $config;
        this.$eloquent = new eloquent_1.Eloquent($item, $config);
        this.$forms = new forms_1.Forms($item, $config);
        this.$filter = new filter_1.Filter($item, $config);
        this.$requests = new requests_1.Requests($item, $config);
        this.$list = new list_1.List($item, $config);
        this.$edit = new edit_1.Edit($item, $config);
        this.$show = new show_1.Show($item, $config);
    }
    transform() {
        this.$item.laravel = {};
        this.$eloquent.transform();
        this.$forms.transform();
        this.$filter.transform();
        this.$requests.transform();
        this.$list.transform();
        this.$edit.transform();
        this.$show.transform();
    }
}
exports.Laravel = Laravel;
