"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.List = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
const base_1 = require("./base");
class List extends base_1.BaseTransformer {
    transform() {
        const fks = this.fks();
        this.$item.laravel.list = {
            layout: this.$config.layout(),
            homeRoute: this.$config.homeRoute(),
            context: naming_1.default.context(this.$item.table),
            header: naming_1.default.listLabel(this.$item.table),
            recordName: naming_1.default.recordName(this.$item.table),
            columns: this.$item.columns.map((column) => {
                let type = column.type;
                let data = null;
                if (fks[column.name]) {
                    type = 'record';
                    data = fks[column.name];
                }
                return {
                    data,
                    type,
                    name: column.name,
                    label: naming_1.default.columnLabel(column),
                    nullable: column.nullable,
                };
            }),
        };
    }
}
exports.List = List;
