"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Requests = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
const th = __importStar(require("../../helpers/type"));
const base_1 = require("./base");
const ignoreCreateRulesFor = {
    created_at: true,
    updated_at: true,
};
class Requests extends base_1.BaseTransformer {
    transform() {
        const model = naming_1.default.modelClass(this.$item.table);
        const result = {
            create: {
                namespace: 'App\\Http\\Requests\\Generathor',
                class: `Create${model}Request`,
                rules: [],
                errorBag: 'create',
            },
            update: {
                namespace: 'App\\Http\\Requests\\Generathor',
                class: `Update${model}Request`,
                rules: [],
                errorBag: 'update',
            },
            filter: {
                namespace: 'App\\Http\\Requests\\Generathor',
                class: `Filter${model}Request`,
                rules: [],
                errorBag: 'filter',
            },
        };
        const fks = this.fks();
        this.$item.columns.forEach((column) => {
            const rules = [];
            const filterRules = [];
            if (!column.nullable && column.type !== 'bool') {
                rules.push('required');
            }
            else {
                rules.push('nullable');
            }
            filterRules.push('nullable');
            if (column.type === 'string' &&
                column.enum &&
                Array.isArray(column.enum)) {
                const rule = 'in:' + column.enum.join(',');
                rules.push(rule);
                filterRules.push(rule);
            }
            const ruleType = th.ruleType(column);
            if (column.type !== 'date') {
                rules.push(ruleType);
                filterRules.push(ruleType);
            }
            const dateRuleType = th.dateRuleType(column);
            if (column.type === 'date' && dateRuleType) {
                rules.push(dateRuleType);
                filterRules.push(dateRuleType);
            }
            if (!column.autoincrement) {
                if (!ignoreCreateRulesFor[column.name]) {
                    result.create.rules.push({
                        attribute: column.name,
                        rules: rules.join('|'),
                    });
                    result.update.rules.push({
                        attribute: column.name,
                        rules: rules.join('|'),
                    });
                }
                const createRange = column.type === 'date' ||
                    (!fks[column.name] &&
                        (column.type === 'int' || column.type === 'float'));
                if (createRange) {
                    const fromInput = column.name + '_from';
                    const toInput = column.name + '_to';
                    result.filter.rules.push({
                        attribute: fromInput,
                        rules: filterRules.join('|'),
                    });
                    result.filter.rules.push({
                        attribute: toInput,
                        rules: filterRules.join('|'),
                    });
                }
                else {
                    result.filter.rules.push({
                        attribute: column.name,
                        rules: filterRules.join('|'),
                    });
                }
            }
        });
        this.$item.laravel.requests = result;
    }
}
exports.Requests = Requests;
