"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Show = void 0;
const naming_1 = __importDefault(require("../../helpers/naming"));
const base_1 = require("./base");
class Show extends base_1.BaseTransformer {
    transform() {
        const context = naming_1.default.context(this.$item.table);
        const fks = this.fks();
        this.$item.laravel.show = {
            layout: this.$config.layout(),
            homeRoute: this.$config.homeRoute(),
            context: context,
            header: naming_1.default.listLabel(this.$item.table),
            listLabel: naming_1.default.listLabel(this.$item.table),
            recordName: naming_1.default.recordName(this.$item.table),
            tabs: this.tabs(context),
            columns: this.$item.columns.map((column) => {
                let type = column.type;
                let data = null;
                if (fks[column.name]) {
                    type = 'record';
                    data = fks[column.name];
                }
                return {
                    data,
                    type,
                    name: column.name,
                    nullable: column.nullable,
                    label: naming_1.default.columnLabel(column),
                };
            }),
        };
    }
    tabs(context) {
        const tabs = [];
        tabs.push({
            label: 'Details',
        });
        for (const relation of this.$item.relations) {
            const relationName = naming_1.default.capitalizedRelationAttribute(relation, this.$item.table);
            tabs.push({
                label: naming_1.default.relationLabel(relation, this.$item.table),
                route: `generathor.${context}.show${relationName}`,
                routeRecord: naming_1.default.recordName(this.$item.table),
            });
        }
        return tabs;
    }
}
exports.Show = Show;
